  option explicit
  Const strURL = "http://checkip.dyndns.org/"
  dim WSHShell, sExec, x, strLineIn, IPaddr, subnet, adapter, gateway, iparray, foundsw, recommend
  dim msgtxt, temp
  dim objHTTP, cnt, resp, WAN, i

  Set WSHShell = CreateObject("WScript.Shell")

' get WAN IP address using HTTPRequest 
  Set objHTTP = CreateObject("MSXML2.XMLHTTP.3.0")
  objHTTP.open "GET", strURL, False

'in case of error once, retry every second...
  On Error Resume Next
  cnt = 1
  objHTTP.send
  If err.Number <> 0 Then
    Do While err.Number <> 0
      objHTTP.send
      WScript.Sleep 1000
      cnt = cnt + 1
      msgbox  cnt
      if cnt >3 then 
        WSHShell.PopUP "Could not connect to " & strURL, 10, "WAN IP Address",  0    '  + 64
        wscript.quit
      end if
    Loop
  End If
  WAN = objHTTP.responseText 
  i = instr(WAN, "IP Address: ")
  if i > 0 then
    WAN = mid(WAN, i+12)
  end if
  i = instr(WAN, "</body>")
  if i > 0 then
    WAN = mid(WAN, 1, i-1)
  end if

'execute IPCONFIG /ALL and extract info from Exec output stream
  set sExec = WSHShell.Exec("ipconfig /all")
  foundsw = false
  Do While Not sExec.StdOut.AtEndOfStream
    strLineIn = sExec.StdOut.ReadLine()
    if instr(strLineIn, "Description") > 0 then
      Adapter = ParseIt(strLineIn) 
    end if
    if instr(strLineIn, "IP Address") > 0 then
      temp = ParseIt(strLineIn) 
      iparray = split(temp, ".", -1, 1)     'IPv4 format "." separator - NOT IPv6 which uses ":"
      if ubound(iparray) = 3 then          
        IPaddr = temp
        foundsw = true                        
        recommend = iparray(0) & "." & iparray(1) & "." & iparray(2) & "." & "254"
      end if       
    end if
    if instr(strLineIn, "Subnet Mask") > 0 then
      subnet = ParseIt(strLineIn) 
    end if
    if instr(strLineIn, "Default Gateway") > 0 then
      gateway = ParseIt(strLineIn) 
      if foundsw then
        exit do                         'found IP address and related info - stop processing stream 
      end if
    end if
  Loop
  msgtxt = "Adapter: " & adapter & vbcrlf & "IP Address: " & IPaddr & vbcrlf & _
               "Subnet mask: " &  subnet & vbcrlf & _
               "Gateway: " & gateway & vbcrlf & _
               "WAN address: " & WAN & vbcrlf & vbcrlf & _
               "Recommended: " & recommend
  msgbox msgtxt, vbinformation, "LAN/WAN info"

public function ParseIt(strIN)
  dim i
  i = instr(strIN, ":")
  if i > 0 then
     Parseit = trim(mid(strIN, i+1))
  else
     ParseIt = strIN
  end if
end function